#include "RunGame.h"

RunGame::RunGame()
{
	memset(left_global_pos, 0, 3 * sizeof(float));

	memset(right_global_pos, 0, 3 * sizeof(float));

	down_wait_after_jump = -1;

	last_left_zupt = 1;
	last_right_zupt = 1;

	last_canva_down = 0;
}




void RunGame::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{


	//ж
	int left_cmd = -1;

	if (left_roll_vec.size() == 0)
	{
		left_roll_vec.push_back(left_att[2]);
	}
	else
	{
		if (left_roll_vec.back() < left_att[2])
		{
			left_roll_vec.push_back(left_att[2]);

			if (left_roll_vec.back() > left_roll_vec.front() + 3000)
			{

				left_cmd = MOTION_LEFT;
				std::cout << "left side" << endl;
				right_roll_vec.clear();
				left_roll_vec.clear();
			}
		}
		else
		{
			left_roll_vec.clear();
		}
	
	}

	int right_cmd = -1;

	if (right_roll_vec.size() == 0 )
	{
		right_roll_vec.push_back(right_att[2]);
	}
	else
	{
		if (right_roll_vec.back() < right_att[2])
		{
			right_roll_vec.push_back(right_att[2]);

			if (right_roll_vec.back() > right_roll_vec.front() + 3000)
			{
				right_cmd = MOTION_RIGHT;

				std::cout << "right side" << endl;
				left_roll_vec.clear();
				right_roll_vec.clear();
			}
		}
		else
		{
			right_roll_vec.clear();
		}

	}



	result[0] = left_cmd;

	result[1] = right_cmd;

	result[2] = getResultJump(jump);

	result[3] = getResultDown(down);


	left_acc_deque.push_back(left_acc[2]);
	right_acc_deque.push_back(right_acc[2]);

	if (left_acc_deque.size() > 5)
	{
		left_acc_deque.pop_front();
		right_acc_deque.pop_front();
	}

	int acc_valid = 0;
	if (left_acc_deque.size() == 5)
	{
		int left_max_val = *(std::max_element(left_acc_deque.begin(), left_acc_deque.end()));
		int left_min_val = *(std::min_element(left_acc_deque.begin(), left_acc_deque.end()));

		int right_max_val = *(std::max_element(right_acc_deque.begin(), right_acc_deque.end()));
		int right_min_val = *(std::min_element(right_acc_deque.begin(), right_acc_deque.end()));


		if (left_max_val - left_min_val < 512 && right_max_val - right_min_val < 512)
		{
			acc_valid = 1;
		}
	}


	//һвܴ׵
	/*if (left_zupt == 0 && right_zupt == 0 && down_wait_after_jump > 0)
	{
		down_wait_after_jump = 10;
	}*/

	//Ʋ
	if (last_left_zupt == 0 && left_zupt == 1 && unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
	{
		addMotionCount(STEP_COUNT);
	}

	if (last_right_zupt == 0 && right_zupt == 1 && unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
	{
		addMotionCount(STEP_COUNT);
	}

	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);

	last_left_zupt = left_zupt;
	last_right_zupt = right_zupt;

}

int RunGame::getResultDown(int down)
{
	int isDown = -1;

	if (last_down == 0 && down > 0)
	{
		isDown = MOTION_DOWN;

		addMotionCount(DOWN_COUNT);

		std::cout << "motion : down" << std::endl;

		//down_count++;
	}

	last_down = down;

	return isDown;

}

int RunGame::getResultJump(int jump)
{
	int isJump = -1;

	if (last_jump == 0 && jump == 1)
	{
		isJump = MOTION_JUMP;

		addMotionCount(JUMP_COUNT);

		std::cout << "motion : jump" << std::endl;

		jump_count++;
	}

	last_jump = jump;

	return isJump;
}



void RunGame::setStepHeading(float& cur_heading, float heading)
{
	cur_heading = heading;
}
